/*
 *
 *  Firmware converter for the 3Com Bluetooth PCMCIA card
 *
 *  Copyright (C) 2001-2002  Marcel Holtmann <marcel@holtmann.org>
 *                           Jose Orlando Pereira <jop@di.uminho.pt>
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation;
 *
 *  Software distributed under the License is distributed on an "AS
 *  IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 *  implied. See the License for the specific language governing
 *  rights and limitations under the License.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include <stdio.h>



int hexa_4(char* ptr) {

	if ((*ptr >= '0') && (*ptr <= '9'))
		return *ptr - '0';

	if ((*ptr >= 'A') && (*ptr <= 'F'))
		return *ptr - 'A' + 10;

	printf("caracter estranho: %c\n", *ptr);

	abort();

}


int hexa_8(char* ptr) {

	return (hexa_4(ptr) << 4) | hexa_4(ptr + 1);

}


int hexa_16(char* ptr) {

	return (hexa_8(ptr) << 8) | hexa_8(ptr + 2);

}


int hexa_32(char* ptr) {

	return (hexa_16(ptr) << 16) | hexa_16(ptr + 4);

}


int main(void) {

	char buf[80];
	int data[1000];
	int dptr = 0;
	int line = 1;
	int last = -1;
	int start = 1;

	while (fgets(buf, 80, stdin)) {
		int size = hexa_8(buf + 2);
		int addr = hexa_32(buf + 4);
		int cs = 0, fcs = hexa_8(buf + 2 + size*2);
		int i, j;

		for (i = 0; i < size; i++)
			cs += hexa_8(buf + 2 + i*2);
		if (((cs + fcs) & 0xff) != 0xff) {
			printf("cs error (line %d): calc=%x file=%x sum=%x\n", line, cs & 0xff, fcs, (cs + fcs) & 0xff);
		}

		switch (buf[1]) {
			case '0':
				break;
			case '3':
				if ((last != -1) && (last != addr)) {
					j = 0;
					printf("\nunsigned short block_at_0x%08x[]={\n", start);
					for (i = 0; i < dptr - 1; i++) {
						printf(" 0x%04x,", data[i]);
						if (++j > 7) {
							printf("\n");
							j=0;
						}
					}
					printf(" 0x%04x\n};\n", data[dptr - 1]);
					last = -1;
				}
				if (last == -1) {
					start = addr;
					dptr = 0;
				}
				last = addr + (size - 4) / 2;
				for (i = 0; i < (size - 4) / 2; i++)
					data[dptr++] = hexa_16(buf + 12 + i*4);
				break;
			case '7':
				j = 0;
				printf("\nunsigned short block_at_0x%08x[]={\n", start);
				for (i = 0; i < dptr - 1; i++) {
					printf(" 0x%04x,", data[i]);
					if (++j > 7) {
						printf("\n");
						j = 0;
					}
				}
				printf(" 0x%04x\n};\n", data[dptr - 1]);
				last = -1;
				break;
		}
		line++;
	}

	return 0;

}
