/* 
   Affix - Bluetooth Protocol Stack for Linux
   Copyright (C) 2001 Nokia Corporation
   Original Author: Dmitry Kasatkin <dmitry.kasatkin@nokia.com>

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2 of the License, or (at your
   option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this program; if not, write to the Free Software Foundation, Inc.,
   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/* 
   $Id: debug.h,v 1.1 2002/07/12 07:38:21 kds Exp $

   DEBUG - control debuging messages

   Fixes:	Dmitry Kasatkin <dmitry.kasatkin@nokia.com>
                Imre Deak <ext-imre.deak@nokia.com>
*/

#ifndef _AFFIX_DEBUG_H
#define _AFFIX_DEBUG_H

#include <affix/types.h>

extern __u32	affix_dbmask;


/*
  These constants control which files/objects have their debugging 
  messages turned on
*/
/* Protocols */
#define DBHCI		BIT0
#define DBL2CAP		BIT1
#define DBRFCOMM	BIT2
#define DBBTY		BIT3
#define DBPAN		BIT4
#define DBAFHCI		BIT5
#define DBAFL2CAP	BIT6
#define DBAFRFCOMM	BIT7
#define DBHCIMGR	BIT10
#define DBHCISCHED	BIT11
#define DBHCILIB	BIT12

/* Drivers */
#define DBUART		BIT8
#define DBUSB		BIT9
#define DBDRV		BIT13

#define DBALLMOD	(DBHCI|DBAFHCI|DBHCIMGR|DBHCISCHED|DBHCILIB | DBL2CAP|DBAFL2CAP |\
			DBRFCOMM|DBAFRFCOMM|DBBTY | DBPAN | DBUART|DBUSB)

/* Types */
#define DBINIT		BIT16
#define DBXMIT		BIT17
#define DBXMITE		BIT18
#define DBRECV		BIT19
#define DBRECVE		BIT20
#define DBCTRL		BIT21
#define DBCTRLE		BIT22
#define DBTIMER		BIT23

#define DBALLTYPE	(DBINIT | DBXMIT | DBXMITE | DBRECV | DBRECVE | DBCTRL | DBCTRLE | DBTIMER)
#define DBALLERROR	(DBXMITE | DBRECVE | DBCTRLE | DBTIMER)

#define DBPARSE		BIT27
#define DBCHARDUMP	BIT28
#define DBDUMP		BIT29
#define DBFNAME		BIT30
#define DBFUNC		BIT31

#define DBALLDETAIL	(DBPARSE | DBCHARDUMP | DBDUMP | DBFNAME | DBFUNC)

#endif
