/* $Id: debug.h,v 1.2 2002/07/15 14:05:47 kds Exp $ */

/************************************************************************************************/
/* kernel log functions */

/************************************************************************************************/
/* includes */

#ifndef _PANDEBUG_H
#define _PANDEBUG_H

//#include "config.h"

/************************************************************************************************/
/* debugging functions */

/* constants to classify debug message */
#define DBG_MISC	 1 /* debug misc, error messages */
#define DBG_BTD		 2 /* debug bt_driver */
#define DBG_NET		 4 /* debug network layer */
#define DBG_TX_DATA	 8 /* debug data flow of packet transmission */
#define DBG_TX_CTRL	16 /* debug data control of packet transmission */
#define DBG_THREAD	32 /* debug connect thread */

/* debug level to filter messages */
#define DBG_LEVEL	0xFF

//#ifdef DEBUG_PROJECT
#ifdef CONFIG_AFFIX_DEBUG
  #define DBG(n, args...)	if(DBG_LEVEL & n) printk(KERN_DEBUG args)
  #define DBG_F(n, args...)	if(DBG_LEVEL & n) printk(KERN_DEBUG "PAN "__FUNCTION__": " args)
  #define DBG_ENTER(n)		if(DBG_LEVEL & n) printk(KERN_DEBUG "PAN "__FUNCTION__": entered\n")
  #define DBG_EXIT(n)		if(DBG_LEVEL & n) printk(KERN_DEBUG "PAN "__FUNCTION__": finished\n")
#else
  #define DBG(n, args...)
  #define DBG_F(n, args...)
  #define DBG_ENTER(n)
  #define DBG_EXIT(n)
#endif

/************************************************************************************************/
/* kernel log */

#define ERR(args...)		printk(KERN_ERR args)
#define WARN(args...)		printk(KERN_WARNING args)
#define	INFO(args...)		printk(KERN_INFO args)

#endif


